local LDBThreat = LibStub("LibDataBroker-1.1"):NewDataObject("LDBThreat", { icon = "Interface\\TARGETINGFRAME\\UI-TargetingFrame-Skull.blp", type = "data source", text = "" })
local UPDATEPERIOD, elapsed = .25, 0

local f = CreateFrame("Frame")

f:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
f:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
f:RegisterEvent("PLAYER_TARGET_CHANGED")
f:RegisterEvent("PARTY_MEMBERS_CHANGED")
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:RegisterEvent("UNIT_TARGET")

local Color = {green = "ff00ff00", blue = "ff00ffff", red = "ffff0000", yellow = "ffffff00", orange = "ffffa500", darkblue = "ff3333ff",}

local CLASS_COLOR_HEX = {
	["DEATHKNIGHT"] = "ffC41F3B",
	["DRUID"] = "ffFF7D0A",
	["HUNTER"] = "ffABD473",
	["MAGE"] = "ff69CCF0",
	["MONK"] = "ff00FF96",
	["PALADIN"] = "ffF58CBA",
	["PRIEST"] = "ffFFFFFF",
	["ROGUE"] = "ffFFF569",
	["SHAMAN"] = "ff2459FF",
	["WARLOCK"] = "ff9482C9",
	["WARRIOR"] = "ffC79C6E",
}

local fademiActive = fademiActive -- set values
local tempthreat = {}--tempthreat -- set values
local currenttarget = currenttarget -- set values

local function GetShortTV(v)
	if v < 1000 and v > -1000 then
		return floor(v)
	elseif v >= 1000000 then
		return format("%.1fM", v/1000000)
	elseif v >= 1000 or v <= -1000 then
		return format("%.1fK", v/1000)
	end
end

local function GetLastThreat(mobId)
local targetGUID = UnitGUID("target")
if UnitCanAttack("player", mobId) then
	tempthreat[UnitGUID(mobId)] = select(5, UnitDetailedThreatSituation("player", mobId))
	if targetGUID == UnitGUID(mobId) then
		currenttarget = tempthreat[UnitGUID(mobId)]
	end
end
end

local function StoreThreat()
	if GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 then
		if GetNumRaidMembers() > 0 then
			for i = 1, GetNumRaidMembers() do
				GetLastThreat("raidtarget"..i)
				GetLastThreat("raidpettarget"..i)
				GetLastThreat("raidtargettarget"..i)
				GetLastThreat("raidpettargettarget"..i)
			end
		else
			for i = 1, GetNumPartyMembers() do
				GetLastThreat("partytarget"..i)
				GetLastThreat("partypettarget"..i)
				GetLastThreat("partytargettarget"..i)
				GetLastThreat("partypettargettarget"..i)
			end
		end

	end
	GetLastThreat("target")
	GetLastThreat("pettarget")
	GetLastThreat("targettarget")
	GetLastThreat("focus")
	GetLastThreat("focustarget")
	GetLastThreat("mouseover")
	GetLastThreat("mouseovertarget")

end

local function GetThreat(unitId, mobId)
	local _, _, _, rawthreatpct, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not rawthreatpct then rawthreatpct = 0 end
	return rawthreatpct
end

local function GetThreatValue(unitId, mobId)
	local _, _, _, _, threatvalue = UnitDetailedThreatSituation(unitId, mobId)
	local areaid = GetCurrentMapAreaID()
	if not threatvalue then threatvalue = 0 end
	if areaid == 824 then threatvalue = threatvalue * 10 end -- Dragon Soul
	return threatvalue
end

local function GetThreatStatus(unitId, mobId)
	local _,status,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	return status
end

local function GetTank(unitId, mobId)
	local isTanking,_,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not isTanking then isTanking = 0 end
	return isTanking
end

local function GetClassColor(unit)
	local unitClass, englishClass = UnitClass(unit)
	local classColor = CLASS_COLOR_HEX[englishClass]
	if not classColor then 
		classColor = "ff848484" --Pets
	end
	return classColor
end

local function UpdateDisplay()
	LDBThreat.text = "LDB-Threat"
	local status = nil
	local highUnit = nil
	local unitThreat = 0
	local highThreat = 0
	local tankName = nil
	local unitThreatValue = 0
	local playerThreatValue = 0
	local partynum = GetNumPartyMembers()
	local raidnum = GetNumRaidMembers()
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "target") and not(UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) then --Solo Target			
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "target")
			highThreat = GetThreat("pet", "target")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then --Solo Target of Target
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")			
		playerThreatValue = GetThreatValue("player", "targettarget")
		if HasPetUI() then
			unitThreatValue = GetThreatValue("pet", "targettarget")
			highThreat = GetThreat("pet", "targettarget")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) then --Raid Target 
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "target")
				end
			unitThreat = GetThreat("raidpet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("raid"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then --Raid Target of Target
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
					unitThreatValue = GetThreatValue("raid"..i, "targettarget")
				end
			unitThreat = GetThreat("raidpet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("raidpet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("raid"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) then  -- Party Target
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		playerThreatValue = GetThreatValue("player", "target")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "target")
				end
			unitThreat = GetThreat("partypet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "target")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "target")
				end
			unitTanking = GetTank("party"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then --Party Target of Target 
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")	
		playerThreatValue = GetThreatValue("player", "targettarget")
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
					unitThreatValue = GetThreatValue("party"..i, "targettarget")
				end
			unitThreat = GetThreat("partypet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
					unitThreatValue = GetThreatValue("partypet"..i, "targettarget")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
					unitThreatValue = GetThreatValue("pet", "targettarget")
				end
			unitTanking = GetTank("party"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	end
	if status == 0 then
		if rawthreatpct < 80 then
			LDBThreat.text = string.format("|c%s%d %%|r", Color.green, rawthreatpct )
			if tankName then
				threatValuediff = ((unitThreatValue - playerThreatValue) / 100 )
				LDBThreat.text = string.format("|c%s%s | %d %% <|r |c%s%s.|r", Color.green, GetShortTV(threatValuediff), rawthreatpct, unitTankingColor, tankName )
				if currenttarget then -- display temporary threat 
					threatValuediff = ((unitThreatValue - currenttarget) / 100 )
					tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
					LDBThreat.text = string.format("|c%s%s | %d %% <|r |c%s%s.|r", Color.blue, GetShortTV(threatValuediff), tempthreatpct, unitTankingColor, tankName )
				end
			end
		end
		if rawthreatpct > 79 and rawthreatpct < 100 then
			LDBThreat.text = string.format("|c%s%d %%|r", Color.yellow, rawthreatpct )
			if tankName then
				threatValuediff = ((unitThreatValue - playerThreatValue) / 100 )
				LDBThreat.text = string.format("|c%s%s | %d %% <|r |c%s%s.|r", Color.yellow, GetShortTV(threatValuediff), rawthreatpct, unitTankingColor, tankName )
				if currenttarget then -- display temporary threat 
					threatValuediff = ((unitThreatValue - currenttarget) / 100 )
					tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
					LDBThreat.text = string.format("|c%s%s | %d %% <|r |c%s%s.|r", Color.blue, GetShortTV(threatValuediff), tempthreatpct, unitTankingColor, tankName )
				end
			end
		end
	elseif status == 1
	then
		LDBThreat.text = string.format("|c%s%d %%|r", Color.orange, rawthreatpct )
		if tankName then
			threatValuediff = ((unitThreatValue - playerThreatValue) / 100 )
			LDBThreat.text = string.format("|c%s%s | %d %% >|r |c%s%s.|r", Color.orange, GetShortTV(threatValuediff), rawthreatpct, unitTankingColor, tankName )
			if currenttarget then -- display temporary threat 
				threatValuediff = ((unitThreatValue - currenttarget) / 100 )
				tempthreatpct = floor((currenttarget / unitThreatValue) * 100)
				LDBThreat.text = string.format("|c%s%s | %d %% <|r |c%s%s.|r", Color.blue, GetShortTV(threatValuediff), tempthreatpct, unitTankingColor, tankName )
			end
		end
	elseif status == 2
	then
		LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.orange )
		if highUnit then
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100 )
			threatdiff = (100 - highThreat)
			LDBThreat.text = string.format("|c%s%s | %d %% >|r |c%s%s.|r", Color.orange, GetShortTV(threatValuediff), threatdiff, highUnitColor, highUnit )
			if currenttarget then -- display temporary threat 
				threatValuediff = ((currenttarget - unitThreatValue) / 100 )
				threatdiff = floor((currenttarget / unitThreatValue) * 100) - highThreat
				LDBThreat.text = string.format("|c%s%s | %d %% >|r |c%s%s.|r", Color.darkblue, GetShortTV(threatValuediff), threatdiff, highUnitColor, highUnit )
			end
		end	
	elseif status == 3
	then
		LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
		if highUnit then
			threatValuediff = ((playerThreatValue - unitThreatValue) / 100)
			threatdiff = (100 - highThreat)
			LDBThreat.text = string.format("|c%s%s | %d %% >|r |c%s%s.|r", Color.red, GetShortTV(threatValuediff), threatdiff, highUnitColor, highUnit )
			if currenttarget then -- display temporary threat 
				threatValuediff = ((currenttarget - unitThreatValue) / 100 )
				threatdiff = floor((currenttarget / unitThreatValue) * 100) - highThreat
				LDBThreat.text = string.format("|c%s%s | %d %% >|r |c%s%s.|r", Color.darkblue, GetShortTV(threatValuediff), threatdiff, highUnitColor, highUnit )
			end
		end
	end
end

function LDBThreat:OnTooltipShow()
	self:AddLine(LDBThreat.text)
	--[[f:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end

	elapsed = 0
	GameTooltip:ClearLines()
	GameTooltip:AddLine(LDBThreat.text)
	GameTooltip:Show()
end)]]
end

--[[function LDBThreat:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
	--GameTooltip:ClearLines()
	LDBThreat.OnTooltipShow(GameTooltip)
	GameTooltip:AddLine(LDBThreat.text)
	GameTooltip:Show()
	
end

function LDBThreat:OnLeave()
	f:SetScript("OnUpdate", nil)
	GameTooltip:Hide()
end]]


local function tContains(table, item)
       local index = 1;
       while table[index] do
               if ( item == table[index] ) then
                       return 1;
               end
               index = index + 1;
       end
       return nil;
end

local function eventHandler(self, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local timestamp, eventtype, hideCaster, srcGUID, srcName, srcFlags, srcFlags2, dstGUID, dstName, dstFlags, dstFlags2 = ...
		local targetGUID = UnitGUID("target")
		local damage
		local playerGUID = UnitGUID("player")
		if srcGUID == playerGUID then
		if eventtype == "SPELL_AURA_APPLIED" then
			local spellID = select(12, ...)
			if spellID == 55342 or spellID == 586 --[[or spellID == 1038]] then
				--DEFAULT_CHAT_FRAME:AddMessage("Temp spell casted") --debug message
				fademiActive = true
				StoreThreat()	-- set temp threat to last known threat value
			elseif spellID == 32612 and fademiActive == true then -- Invisibility buff while Mirror Image is active
				wipe(tempthreat)	
			end
		elseif eventtype == "SPELL_DAMAGE" or eventtype == "RANGE_DAMAGE" or eventtype == "SPELL_PERIODIC_DAMAGE" then
			if fademiActive == true then
			--DEFAULT_CHAT_FRAME:AddMessage("Detecting damage") --debug message
			damage = select(15, ...)
			
			end
		elseif eventtype == "SWING_DAMAGE" then
			if fademiActive == true then
			damage = select(12, ...)
			
			end
		elseif eventtype == "SPELL_AURA_REMOVED" then
			local spellID = select(12, ...)
			if spellID == 55342 or spellID == 586 --[[or spellID == 1038]] then
				--DEFAULT_CHAT_FRAME:AddMessage("Temp spell expired") --debug message
				wipe(tempthreat) -- clear table
				damage = nil
				fademiActive = nil
				currenttarget = nil
			end	
		end
		if damage then
			tempthreat[dstGUID] = (tempthreat[dstGUID] or 0) + damage * 100
			if targetGUID == dstGUID then
				currenttarget = tempthreat[dstGUID]
			end
		end
		end
	elseif event == "PLAYER_TARGET_CHANGED" then
		local targetGUID = UnitGUID("target")
		if fademiActive == true then
			local intable = tContains(tempthreat, targetGUID)
			if not intable then
				currenttarget = nil
				--DEFAULT_CHAT_FRAME:AddMessage("currentarget set to nil") -- debug message
			end
			for index,value in pairs(tempthreat) do 
				if targetGUID == index then
					currenttarget = value
					--DEFAULT_CHAT_FRAME:AddMessage(tostring(index).." : "..tostring(value)) -- debug message
				
				end
			
			end
		end

		UpdateDisplay()
	elseif event == "UNIT_TARGET" then
		if UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) then
			f:SetScript("OnUpdate", function(self, elap)
			elapsed = elapsed + elap
			if elapsed < UPDATEPERIOD then return end

			elapsed = 0
			UpdateDisplay()
			end)
		else
			f:SetScript("OnUpdate", nil)
		end
	else
		UpdateDisplay()
	end
end
f:SetScript("OnEvent", eventHandler)